import { Prisma } from '@prisma/client';
import { ArgsWithCache, CacheOptions } from './types';
export declare function cache(opts: CacheOptions): (client: any) => {
    $extends: {
        extArgs: {
            result: {};
            model: {
                $allModels: {
                    findUnique: () => <T, Args extends ArgsWithCache<T, "findUnique">>(this: T, args?: Args | undefined) => Promise<Prisma.Result<T, "findUnique", Args>>;
                    findUniqueOrThrow: () => <T_1, Args_1 extends ArgsWithCache<T_1, "findUniqueOrThrow">>(this: T_1, args?: Args_1 | undefined) => Promise<Prisma.Result<T_1, "findUniqueOrThrow", Args_1>>;
                    findFirst: () => <T_2, Args_2 extends ArgsWithCache<T_2, "findFirst">>(this: T_2, args?: Args_2 | undefined) => Promise<Prisma.Result<T_2, "findFirst", Args_2>>;
                    findFirstOrThrow: () => <T_3, Args_3 extends ArgsWithCache<T_3, "findFirstOrThrow">>(this: T_3, args?: Args_3 | undefined) => Promise<Prisma.Result<T_3, "findFirstOrThrow", Args_3>>;
                    findMany: () => <T_4, Args_4 extends ArgsWithCache<T_4, "findMany">>(this: T_4, args?: Args_4 | undefined) => Promise<Prisma.Result<T_4, "findMany", Args_4>>;
                    count: () => <T_5, Args_5 extends ArgsWithCache<T_5, "count">>(this: T_5, args?: Args_5 | undefined) => Promise<Prisma.Result<T_5, "count", Args_5>>;
                    aggregate: () => <T_6, Args_6 extends ArgsWithCache<T_6, "aggregate">>(this: T_6, args?: Args_6 | undefined) => Promise<Prisma.Result<T_6, "aggregate", Args_6>>;
                    groupBy: () => <T_7, Args_7 extends ArgsWithCache<T_7, "groupBy">>(this: T_7, args?: Args_7 | undefined) => Promise<Prisma.Result<T_7, "groupBy", Args_7>>;
                    clearCache: () => () => Promise<void>;
                };
                planet: {
                    findUnique: () => <T, Args extends ArgsWithCache<T, "findUnique">>(this: T, args?: Args | undefined) => Promise<Prisma.Result<T, "findUnique", Args>>;
                    findUniqueOrThrow: () => <T_1, Args_1 extends ArgsWithCache<T_1, "findUniqueOrThrow">>(this: T_1, args?: Args_1 | undefined) => Promise<Prisma.Result<T_1, "findUniqueOrThrow", Args_1>>;
                    findFirst: () => <T_2, Args_2 extends ArgsWithCache<T_2, "findFirst">>(this: T_2, args?: Args_2 | undefined) => Promise<Prisma.Result<T_2, "findFirst", Args_2>>;
                    findFirstOrThrow: () => <T_3, Args_3 extends ArgsWithCache<T_3, "findFirstOrThrow">>(this: T_3, args?: Args_3 | undefined) => Promise<Prisma.Result<T_3, "findFirstOrThrow", Args_3>>;
                    findMany: () => <T_4, Args_4 extends ArgsWithCache<T_4, "findMany">>(this: T_4, args?: Args_4 | undefined) => Promise<Prisma.Result<T_4, "findMany", Args_4>>;
                    count: () => <T_5, Args_5 extends ArgsWithCache<T_5, "count">>(this: T_5, args?: Args_5 | undefined) => Promise<Prisma.Result<T_5, "count", Args_5>>;
                    aggregate: () => <T_6, Args_6 extends ArgsWithCache<T_6, "aggregate">>(this: T_6, args?: Args_6 | undefined) => Promise<Prisma.Result<T_6, "aggregate", Args_6>>;
                    groupBy: () => <T_7, Args_7 extends ArgsWithCache<T_7, "groupBy">>(this: T_7, args?: Args_7 | undefined) => Promise<Prisma.Result<T_7, "groupBy", Args_7>>;
                    clearCache: () => () => Promise<void>;
                };
            };
            query: {};
            client: {
                clearCache: () => () => Promise<void>;
            };
        };
    };
};
export * from './types';
export * from './storage';
